<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Load all orders - Danh sách đơn hàng</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<script>
    $(document).ready(function () {

        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gORDER_CODE_COL = 0;
        const gKICH_CO_COMBO_COL = 1;
        const glOAI_PIZZA_COL = 2;
        const gNUOC_UONG_COL = 3;
        const gTHANH_TIEN_COL = 4;
        const gHO_TEN_COL = 5;
        const gSO_DT_COL = 6;
        const gTRANG_THAI_COL = 7;
        const gACTION_COL = 8;

        const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";

        const gCOL_NAME = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"];

        // định nghĩa table  - chưa có data
        var gOderTable = $("#order-table").DataTable({
            // Khai báo các cột của datatable
            "columns": [
                { "data": gCOL_NAME[gORDER_CODE_COL] },
                { "data": gCOL_NAME[gKICH_CO_COMBO_COL] },
                { "data": gCOL_NAME[glOAI_PIZZA_COL] },
                { "data": gCOL_NAME[gNUOC_UONG_COL] },
                { "data": gCOL_NAME[gTHANH_TIEN_COL] },
                { "data": gCOL_NAME[gHO_TEN_COL] },
                { "data": gCOL_NAME[gSO_DT_COL] },
                { "data": gCOL_NAME[gTRANG_THAI_COL] },
                { "data": gCOL_NAME[gACTION_COL] },
            ],
            // Ghi đè nội dung của cột action, chuyển thành button chi tiết
            "columnDefs": [
                {
                    "targets": gACTION_COL,
                    "defaultContent": "<button class='info-order btn btn-info'>Chi tiết</button>"
                }]
        });
        var gOrder_list = [];
        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        onPageLoading();
        // gán click event handler cho button chi tiet
        $("#order-table").on("click", ".info-order", function () {
            onButtonChiTietClick(this); // this là button được ấn
        });
        $("#btn-filter").on("click", function () {
            // Tiến hành lọc dữ liệu
            onFilterData();
        });
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm thực hiện khi load trang
        function onPageLoading() {
            // lấy data từ server
            $.ajax({
                url: gBASE_URL,
                type: "GET",
                dataType: 'json',
                success: function (responseObject) {
                    gOrder_list = responseObject;
                    loadDataToTable(responseObject);
                },
                error: function (error) {
                    console.assert(error.responseText);
                }
            });
        }
        // Hàm xử lý khi ấn nút chi tiết
        function onButtonChiTietClick(paramChiTietButton) {
            //Xác định thẻ tr là cha của nút được chọn
            var vRowSelected = $(paramChiTietButton).parents('tr');
            //Lấy datatable row
            var vDatatableRow = gOderTable.row(vRowSelected);
            //Lấy data của dòng 
            var vOrderData = vDatatableRow.data();
            console.log(vOrderData);
        }
              // Hàm để lọc dữ liệu
      function onFilterData() {
        // Chuẩn bị dữ liệu đầu vào
        var vFilterObj = {
          trangThai: "",
          loaiPizza: ""
        }

        getDataFromFilter(vFilterObj);

        // Xử lý dữ liệu đầu vào
        var vOrdeListFilter = filterData(vFilterObj);

        // Xử lý dữ liệu đầu ra
        loadDataToTable(vOrdeListFilter);
      }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // load data to table
        function loadDataToTable(paramResponseObject) {
            //Xóa toàn bộ dữ liệu đang có của bảng
            gOderTable.clear();
            //Cập nhật data cho bảng 
            gOderTable.rows.add(paramResponseObject);
            //Cập nhật lại giao diện hiển thị bảng
            gOderTable.draw();
        }
              // Lấy data từ input
      function getDataFromFilter(paramFilterObj) {
        paramFilterObj.trangThai = $("#select-trang-thai").val();
        paramFilterObj.loaiPizza = $("#select-loai-pizza").val();
      }
            //Hàm tiến hành lọc dữ liệu
      // Input: dữ liệu firstname, lastname filter; biến global userlist
      // Ouput: danh sách user đã được lọc
      function filterData(paramFilterObj) {
        var vResult = [];
        // Tiến hành lọc
        vResult = gOrder_list.filter((paramOrder) => {
          return  (paramFilterObj.trangThai == "" || paramOrder.trangThai === paramFilterObj.trangThai)
              &&
              (paramFilterObj.loaiPizza == "" || paramOrder.loaiPizza === paramFilterObj.loaiPizza)
        })

        return vResult;
      }
    });
</script>

<body>
    <div class="container">
        <h2 class="text-center">DANH SÁCH ĐƠN HÀNG</h2>
        <div class="row jumbotron">
            <div class="col-2">
                <label class="form-label" for="select-trang-thai">Trạng thái Order</label>
            </div>
            <div class="col-3">
                <select id="select-trang-thai">
                    <option value="">(all)</option>
                    <option value="open">open</option>
                    <option value="confirmed">confirmed</option>
                    <option value="cancel">cancel</option>
                </select>
            </div>
            <div class="col-2">
                <label class="form-label" for="select-loai-pizza">Loại Pizza</label>
            </div>
            <div class="col-3">
                <select id="select-loai-pizza">
                    <option value="">(all)</option>
                    <option value="hawaii">hawaii</option>
                    <option value="bacon">bacon</option>
                    <option value="seafood">seafood</option>
                </select>
            </div>
            <div class="col-2">
                <button class="btn btn-success" id="btn-filter">Lọc dữ liệu</button>
            </div>
        </div>
    </div>
    <div class="container-fluid">
        <div class="row">
            <div class="col-12">
                <table class="table table-bordered table-striped table-hover" id="order-table">
                    <thead>
                        <tr>
                            <th scope="col">Order Code</th>
                            <th scope="col">Kích cỡ combo</th>
                            <th scope="col">Loại pizza</th>
                            <th scope="col">Nước uống</th>
                            <th scope="col">Thành tiền</th>
                            <th scope="col">Họ và tên</th>
                            <th scope="col">Số điện thoại</th>
                            <th scope="col">Trạng thái</th>
                            <th scope="col">Chi tiết</th>
                        </tr>
                    </thead>
                    <tbody>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</body>

</html>